var hyperlog = require('hyperlog')
var level = require('level')
var osmdb = require('..')
var fdstore = require('fd-chunk-store')
var rimraf = require('rimraf')

var osm = osmdb({
  log: hyperlog(level('./copy'), { valueEncoding: 'json' }),
  db: level('index1'),
  store: fdstore(4096, 'kdb1')
})

var osm2 = osmdb({
  log: hyperlog(level('log2'), { valueEncoding: 'json' }),
  db: level('index2'),
  store: fdstore(4096, 'kdb2')
})

// var batch = []
// var n = 3000
// var spread = 0.5
// console.log('inserting', n, 'documents')
// for (var i=0; i < n; i++) {
//   var node = {
//     type: 'node',
//     lat: Number(Math.random() * spread - spread/2),
//     lon: Number(Math.random() * spread - spread/2),
//   }
//   batch.push({ type: 'put', key: ''+i, value: node })
// }

// console.time('batch')
// osm.batch(batch, function (err, res) {
//   console.timeEnd('batch')
  console.time('indexing')
  osm.ready(function () {
    console.timeEnd('indexing')
    console.time('query')
    var s = 0.005 / 2
    // s *= 3
    var at = [-1.2210000,-77.293000]
    osm.query([[at[0]-s,at[0]+s],[at[1]-s,at[1]+s]], function (err, res) {
    console.timeEnd('query')
      cleanup(function () {
        console.log('done', res.length)
      })
    })
    // console.time('replicate')
    // replicate(function () {
    //   console.timeEnd('replicate')
    // })
  })
// })

function replicate (cb) {
  var r1 = osm.log.replicate()
  var r2 = osm2.log.replicate()

  r1.pipe(r2).pipe(r1)

  r1.on('end', done)
  r2.on('end', done)

  var pending = 2
  function done () {
    if (!--pending) cb()
  }
}

function cleanup (cb) {
  rimraf.sync('./log1')
  rimraf.sync('./kdb1')
  rimraf.sync('./index1')
  rimraf.sync('./log2')
  rimraf.sync('./kdb2')
  rimraf.sync('./index2')
  process.nextTick(cb)
}
