var level = require('level')
var hlog = require('hyperlog')
var hyperkv = require('hyperkv')
var memdb = require('memdb')

var db = level('/home/sww/.config/Electron/data/log')
var log = hlog(db, { valueEncoding: 'json' })
var kv = hyperkv({log: log, db: memdb()})

var outdb = level('./copy')
var outlog = hlog(outdb, { valueEncoding: 'json' })
var outkv = hyperkv({log: outlog, db: memdb()})

var batch = []
kv.createReadStream()
  .on('data', function (row) {
    var values = Object.keys(row.values).map(function (k) { return row.values[k] })
    values.forEach(function (v) {
      if (!v.value) return
      process.stdout.write('.')
      batch.push({
        type: 'put',
        key: row.key,
        value: v.value
      })
    })
  })
  .on('end', doImport.bind(null, batch))

function doImport (ops) {
  console.log('batch importing..', ops.length)
  outkv.batch(ops, console.log)
}
